import { Component, Input } from '@angular/core';
import { BehaviorSubject } from 'rxjs/Rx';
var StepperContainerComponent = /** @class */ (function () {
    function StepperContainerComponent() {
        this.statusLabelList = [
            { title: 'Not started', backgroundColor: '' },
            { title: 'In Progress', backgroundColor: '' },
            { title: 'Completed', backgroundColor: '' },
            { title: 'Draft', backgroundColor: '' }
        ];
        this.activeListItem = new BehaviorSubject(null);
    }
    StepperContainerComponent.prototype.ngOnInit = function () {
        var firstItem = (this.navbarList[0] && this.navbarList[0].itemList) ? this.navbarList[0].itemList[0] : null;
        if (firstItem) {
            this.activeItemId = 'id-0-0';
        }
        this.activeListItem.next(firstItem);
    };
    StepperContainerComponent.prototype.selectItem = function (item) {
        if (this.activeListItem.value != item) {
            this.activeListItem.next(item);
            var keyA = 0;
            for (var _i = 0, _a = this.navbarList; _i < _a.length; _i++) {
                var nb = _a[_i];
                if (nb && nb.itemList) {
                    var keyB = 0;
                    for (var _b = 0, _c = nb.itemList; _b < _c.length; _b++) {
                        var nbIt = _c[_b];
                        if (item === nbIt) {
                            this.activeItemId = "id-" + keyA + "-" + keyB;
                            this.navbarList[keyA].itemList[keyB].status = 1;
                        }
                        else {
                            this.navbarList[keyA].itemList[keyB].status = 0;
                        }
                        keyB++;
                    }
                }
                keyA++;
            }
        }
    };
    StepperContainerComponent.prototype.handleNavigation = function (direction) {
        if (direction === void 0) { direction = false; }
        var tempId = this.activeItemId.split('id-')[1];
        var _a = (tempId && tempId.length) ? tempId.split('-') : [null, null], navListIndex1 = _a[0], itemListIndex1 = _a[1];
        if (navListIndex1 === null || itemListIndex1 === null) {
            return;
        }
        var navListIndex = parseInt(navListIndex1, 10);
        var itemListIndex = parseInt(itemListIndex1, 10);
        if (direction) {
            // Check if current itemListIndex is less than the max itemListIndex
            if (itemListIndex < this.navbarList[navListIndex].itemList.length - 1) {
                var itemToBeSelected = this.navbarList[navListIndex].itemList[itemListIndex + 1];
                if (itemToBeSelected.disabled || (!itemToBeSelected.component)) {
                    return;
                }
                this.selectItem(itemToBeSelected);
            }
            else {
                // If currentItemListIndex is not less than the max itemListIndex check for another navList and it's max index
                if ((navListIndex + 1) <= this.navbarList.length - 1) {
                    if (0 < this.navbarList[navListIndex + 1].itemList.length - 1) {
                        var itemToBeSelected = this.navbarList[navListIndex + 1].itemList[0];
                        if (itemToBeSelected.disabled || (!itemToBeSelected.component)) {
                            return;
                        }
                        this.selectItem(itemToBeSelected);
                    }
                }
            }
        }
        else {
            // Check if current itemListIndex is more than the min itemListIndex i.e. 0
            if (itemListIndex > 0) {
                var itemToBeSelected = this.navbarList[navListIndex].itemList[itemListIndex - 1];
                if (itemToBeSelected.disabled || (!itemToBeSelected.component)) {
                    return;
                }
                this.selectItem(itemToBeSelected);
            }
            else {
                // If currentItemListIndex is less than the zero check
                // for previous navList and it's min index is greater than or equal to zero select the max item from that list
                if ((navListIndex - 1) >= 0) {
                    if (this.navbarList[navListIndex - 1].itemList.length - 1 >= 0) {
                        var itemToBeSelected = this.navbarList[navListIndex - 1]
                            .itemList[this.navbarList[navListIndex - 1].itemList.length - 1];
                        if (itemToBeSelected.disabled || (!itemToBeSelected.component)) {
                            return;
                        }
                        this.selectItem(itemToBeSelected);
                    }
                }
            }
        }
    };
    StepperContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'stepper-container-cmp',
                    template: "\n    <div class=\"container-fluid\">\n      <div class=\"row\">\n        <div class=\"col-lg-3 col-md-3 col-sm-3 col-xs-3 stepper-navbar-container\">\n          <stepper-navbar-cmp [statusLabelList]=\"statusLabelList\" [activeListItem]=\"activeListItem\" [activeItemId]=\"activeItemId\" [navbarList]=\"navbarList\" (onItemClick)=\"selectItem($event)\"></stepper-navbar-cmp>\n        </div>\n        <div class=\"col-lg-7 col-md-7 col-sm-7 col-xs-7 stepper-view\">\n          <stepper-view-cmp [activeListItem]=\"activeListItem\" (navigate)=\"handleNavigation($event)\"></stepper-view-cmp>\n        </div>\n      </div>\n    </div>\n  ",
                    styles: ["\n    .stepper-navbar-container{box-shadow:0 3px 5px 1px #CCC}.stepper-sidebar{border-left:1px solid #000}\n  "]
                },] },
    ];
    /** @nocollapse */
    StepperContainerComponent.ctorParameters = function () { return []; };
    StepperContainerComponent.propDecorators = {
        "navbarList": [{ type: Input },],
        "statusLabelList": [{ type: Input },],
    };
    return StepperContainerComponent;
}());
export { StepperContainerComponent };
//# sourceMappingURL=stepper-container.component.js.map