import { ComponentFactoryResolver, Injectable } from '@angular/core';
var ComponentFactoryService = /** @class */ (function () {
    function ComponentFactoryService(factoryResolver) {
        this.factoryResolver = factoryResolver;
    }
    ComponentFactoryService.prototype.createComponent = function (rootViewContainer, dIComponent) {
        var factory = this.factoryResolver
            .resolveComponentFactory(dIComponent);
        var component = factory
            .create(rootViewContainer.parentInjector);
        rootViewContainer.insert(component.hostView);
        return component;
    };
    ComponentFactoryService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ComponentFactoryService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver, },
    ]; };
    return ComponentFactoryService;
}());
export { ComponentFactoryService };
//# sourceMappingURL=component-factory.service.js.map